# Interface DomainObjectSet<T>

Type Parameters:
  `T` - The type of objects in this set.

All Superinterfaces:
  `Collection<T>, DomainObjectCollection<T>, Iterable<T>, Set<T>`

All Known Subinterfaces:
  `ArtifactTransformReports, ArtifactTypeContainer, AuthenticationContainer, BinaryTasksCollection, BuildDashboardReports, BuildTypeContainer, CheckstyleReports, CodeNarcReports, ConfigurationContainer, ConfigurationReports, DependencyConstraintSet, DependencyReportContainer, DependencySet, DistributionContainer, ExtensiblePolymorphicDomainObjectContainer<T>, FlavorContainer, IvyArtifactSet, IvyConfigurationContainer, JacocoReportsContainer, MavenArtifactSet, MutableVersionCatalogContainer, NamedDomainObjectContainer<T>, NamedDomainObjectSet<T>, NativeExecutableBinarySpec.TasksCollection, NativeTestSuiteBinarySpec.TasksCollection, NativeToolChainRegistry, PlatformContainer, PluginCollection<T>, PluginContainer, PmdReports, PolymorphicDomainObjectContainer<T>, PrebuiltLibraries, ProjectSourceSet, PublicationContainer, PublishArtifactSet, ReportContainer<T>, Repositories, SharedLibraryBinarySpec.TasksCollection, SoftwareComponentContainer, SourceSetContainer, StaticLibraryBinarySpec.TasksCollection, TaskCollection<T>, TaskContainer, TestSuiteTaskCollection, TestTaskReports`

@ManagedType public interface DomainObjectSet<T> extends DomainObjectCollection<T>, Set<T>

A `DomainObjectSet` is a specialization of `DomainObjectCollection` that guarantees `Set` semantics.

Since:
  1.0
See Also:
  - Create an instance of this as a managed property (preferred).
  - Create an instance of this manually.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Set<T>`
  `findAll(Closure spec)`
  Deprecated.
  `DomainObjectSet<T>`
  `matching(Closure spec)`
  Returns a collection which contains the objects in this collection which meet the given closure specification.
  `DomainObjectSet<T>`
  `matching(Spec<? super T> spec)`
  Returns a collection which contains the objects in this collection which meet the given specification.
  `<S extends T>
  DomainObjectSet<S>`
  `withType(Class<S> type)`
  Returns a collection containing the objects in this collection of the given type.

  ### Methods inherited from interface Collection

  `parallelStream, removeIf, stream, toArray`

  ### Methods inherited from interface DomainObjectCollection

  `addAllLater, addLater, all, all, configureEach, disallowChanges, getElements, whenObjectAdded, whenObjectAdded, whenObjectRemoved, whenObjectRemoved, withType, withType`

  ### Methods inherited from interface Iterable

  `forEach`

  ### Methods inherited from interface Set

  `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, spliterator, toArray, toArray`

- ## Method Details

  - ### withType

    <S extends T> DomainObjectSet<S> withType(Class<S> type)
    Returns a collection containing the objects in this collection of the given type. The returned collection is live, so that when matching objects are later added to this collection, they are also visible in the filtered collection.

    This method is an intermediate operation. It does not change the realized/unrealized state of the elements in the collection.

    Specified by:
      `withType` in interface `DomainObjectCollection<T>`
    Parameters:
      `type` - The type of objects to find.
    Returns:
      The matching objects. Returns an empty collection if there are no such objects in this collection.

  - ### matching

    DomainObjectSet<T> matching(Spec<? super T> spec)
    Returns a collection which contains the objects in this collection which meet the given specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.

    This method is an intermediate eager operation. The application of the filter forces the realization of the collection elements.

    Specified by:
      `matching` in interface `DomainObjectCollection<T>`
    Parameters:
      `spec` - The specification to use.
    Returns:
      The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

  - ### matching

    DomainObjectSet<T> matching(Closure spec)
    Returns a collection which contains the objects in this collection which meet the given closure specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.

    This method is an intermediate eager operation. The application of the filter forces the realization of the collection elements.

    Specified by:
      `matching` in interface `DomainObjectCollection<T>`
    Parameters:
      `spec` - The specification to use. The closure gets a collection element as an argument.
    Returns:
      The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

  - ### findAll

    @Deprecated Set<T> findAll(Closure spec)
    Deprecated.
    Returns a collection which contains the objects in this collection which meet the given closure specification.

    This method is an eager operation. The application of the filter forces the realization of all of the underlying collection elements.

    Specified by:
      `findAll` in interface `DomainObjectCollection<T>`
    Parameters:
      `spec` - The specification to use. The closure gets a collection element as an argument.
    Returns:
      The collection of matching objects. Returns an empty collection if there are no such objects in this collection.